// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// RelationQuery relation query
//
// swagger:model RelationQuery
type RelationQuery struct {

	// Namespace of the Relation Tuple
	// Required: true
	Namespace *string `json:"namespace"`

	// Object of the Relation Tuple
	Object string `json:"object,omitempty"`

	// Relation of the Relation Tuple
	Relation string `json:"relation,omitempty"`

	// SubjectID of the Relation Tuple
	//
	// Either SubjectSet or SubjectID can be provided.
	SubjectID string `json:"subject_id,omitempty"`

	// subject set
	SubjectSet *SubjectSet `json:"subject_set,omitempty"`
}

// Validate validates this relation query
func (m *RelationQuery) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateNamespace(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSubjectSet(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *RelationQuery) validateNamespace(formats strfmt.Registry) error {

	if err := validate.Required("namespace", "body", m.Namespace); err != nil {
		return err
	}

	return nil
}

func (m *RelationQuery) validateSubjectSet(formats strfmt.Registry) error {
	if swag.IsZero(m.SubjectSet) { // not required
		return nil
	}

	if m.SubjectSet != nil {
		if err := m.SubjectSet.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("subject_set")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("subject_set")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this relation query based on the context it is used
func (m *RelationQuery) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateSubjectSet(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *RelationQuery) contextValidateSubjectSet(ctx context.Context, formats strfmt.Registry) error {

	if m.SubjectSet != nil {
		if err := m.SubjectSet.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("subject_set")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("subject_set")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *RelationQuery) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *RelationQuery) UnmarshalBinary(b []byte) error {
	var res RelationQuery
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
